import Vue from 'vue';
import {
  ZdECharts,
  echartsCore,
  echartsCharts,
  echartsComponents,
} from '@zeedhi/zd-echarts';
import { ZdCrosstab } from '@zeedhi/zd-crosstab';
import { ZdColorPicker } from '@zeedhi/zd-color-picker';
import App from './App.vue';
import router from './router';
import { vuetify } from './plugins';
import store from './store';
import './components';
import './registerServiceWorker';
import 'roboto-fontface/css/roboto/roboto-fontface.css';
import './styles/style.scss';

Vue.component('ZdECharts', ZdECharts);
Vue.component('ZdCrosstab', ZdCrosstab);
Vue.component('ZdColorPicker', ZdColorPicker);
echartsCore.use([
  echartsCharts.GaugeChart,
  echartsCharts.PieChart,
  echartsCharts.BarChart,
  echartsCharts.LineChart,
  echartsComponents.ToolboxComponent,
  echartsComponents.GridComponent,
  echartsComponents.DataZoomComponent,
]);

Vue.config.productionTip = false;

new Vue({
  router,
  vuetify,
  store,
  render: (h) => h(App),
}).$mount('#app');
